import 'package:flutter/widgets.dart';
import 'package:nui_core/busevent/nui_busevent.dart';
import 'package:nui_core/nui_core.dart';
import 'nui_theme.dart';

typedef NUIThemeChildBuilder = Widget Function(BuildContext context, NUIColorTheme theme);

class NUIThemeContainer extends StatefulWidget {
  NUIThemeContainer({@required this.builder});
  final NUIThemeChildBuilder builder;

  @override
  _NUIThemeContainerState createState() => _NUIThemeContainerState();
}

class _NUIThemeContainerState extends State<NUIThemeContainer> {
  String _identity;

  @override
  void initState(){
    super.initState();
    _identity = randomUUID();
    NUIBusEvent.get(module: NUITheme.BROADCAST_THEME_MODULE).listenInvoke(_identity, listener: (event){
      if(match(event.code, NUITheme.CODE_THEME_SWITCHED)){
        //Theme switched
        logNUI("NUIThemeContainer", "Switching theme ...");
        setState(() {
          //Calling set state to update the items and their theme color
        });
      }
    });
  }

  @override
  void dispose(){
    super.dispose();
    logNUI("NUIThemeContainer", "Disposed bus event listener");
    NUIBusEvent.get(module: NUITheme.BROADCAST_THEME_MODULE).disposeInvoke(_identity);
  }

  @override
  Widget build(BuildContext context) {
    final currentTheme = colorTheme;
    return widget.builder(context, currentTheme);
  }
}
